<template>
  <div v-if="!arbaloProfile.registration_completed" class="modal is-active">
    <div class="modal-background"></div>
    <div class="modal-card">
      <header class="modal-card-head">
        <p class="modal-card-title">Registration almost completed</p>
      </header>

      <section class="modal-card-body">
        <div class="control">
          <div
            v-if="message && !acceptedTermsAndConditions"
            class="notification is-warning"
          >{{message}}</div>
          <label class="checkbox is-large">
            <input type="checkbox" id="termsAndConditions" v-model="acceptedTermsAndConditions" />
            I agree to the
            <a href="#">terms and conditions</a>
          </label>
        </div>
      </section>
      <footer class="modal-card-foot">
        <div class="control">
          <button v-on:click="handleTermsAndConditionsApproval()" class="button is-info">Send</button>
        </div>
      </footer>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import arbaloExtensions from "@/services/arbalo_extensions/service";

@Component
export default class ARegistrationModal extends Vue {
  acceptedTermsAndConditions: boolean = false;
  message: string = "";

  extensions_service = arbaloExtensions({
    baseURL: this.$store.state.serviceBrokerAPIBaseURL
  });

  get arbaloProfile() {
    return this.$store.getters["user/getArbaloProfile"]();
  }

  handleTermsAndConditionsApproval() {
    if (!this.acceptedTermsAndConditions) {
      this.message = "Please accept the terms and conditions";
      return;
    }
    this.extensions_service
      .completeRegistration(this.arbaloProfile.keycloak_uuid, {
        terms_and_conditions_accepted: this.acceptedTermsAndConditions
      })
      .then(updatedArbaloProfile => {
        if (updatedArbaloProfile) {
          this.$store.commit("user/setArbaloProfile", updatedArbaloProfile);
        }
      })
      .catch(err => {
        console.log(err);
      });
  }
}
</script>
